program AutoRun;

{************************************************************************
*                                                                       *
*                AutoRun: Automatically run Web browser                 *
*                   Copyright (C) 2000, John Zaitseff                   *
*                                                                       *
************************************************************************}

{ Author:    John Zaitseff <J.Zaitseff@zap.org.au>
  Date:      8th May, 2000.
  Version:   1.0

  This program opens the user's Web browser to the file "index.htm" or
  "index.html" in the same directory as the executable.  The rationale
  behind this is to automatically open up an introductory HTML page on
  a CD-ROM.

  Using this program as a CD-ROM AutoRun application requires placing
  this program (AUTORUN.EXE), the HTML page (index.htm or index.html)
  and a correct AUTORUN.INF file in the root directory of the CD-ROM.

  The AUTORUN.INF file needs to look like the following:

      [autorun]
      open=autorun.exe
      icon=autorun.ico


  This program is free software, and may be distributed and/or modified
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either Version 2 of the License or any later
  version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program (in the file LICENSE.TXT); if not, write to:
            Free Software Foundation, Inc.,
            675 Mass Ave, Cambridge, MA 02139, USA.

  Your comments, suggestions, corrections and enhancements are always
  welcome!  Please send these to:

  Postal:   John Zaitseff,
            4 McCabe Close,
            Menai, NSW, 2234,
            Australia.
  E-mail:   J.Zaitseff@zap.org.au
  Web:      http://www.zap.org.au/software/autorun/
}


{$R *.RES}


uses
  Windows, ShellAPI, SysUtils;


const
  Caption       = 'Automatically run HTML index file';
  IndexFiles    : array [1..2] of string =
                    ('index.htm', 'index.html');

var
  IndexFN : string;
  CurDir  : string;
  I       : integer;

begin  { Main }
  { Determine the executable's directory }
  CurDir := ExtractFileDir(ParamStr(0));
  if CurDir = '' then
    CurDir := '.';
  if CurDir[Length(CurDir)] <> '\' then
    CurDir := CurDir + '\';

  { Find the HTML index file }
  for I := Low(IndexFiles) to High(IndexFiles) do
    begin
      IndexFN := CurDir + IndexFiles[I];
      if FileExists(IndexFN) then
        begin
          IndexFN := ExpandFileName(IndexFN);

          { Open the HTML index file }
          if ShellExecute(0, 'open', PChar(IndexFN), nil, nil,
                          SW_SHOWNORMAL) <= 32 then
            begin
              MessageBox(0, PChar(SysErrorMessage(GetLastError)), Caption,
                         MB_OK + MB_ICONSTOP)
            end;
          Halt(0)
        end
    end;

  MessageBox(0, PChar('The file "' + IndexFiles[Low(IndexFiles)] +
             '" is not present in the program directory'),
             Caption, MB_OK + MB_ICONSTOP);
end.

